package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/gin-gonic/gin/binding"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineApiGroup struct {
	api.Api
}

// GetPage 获取用户绑定从属关系表列表
// @Summary 获取用户绑定从属关系表列表
// @Description 获取用户绑定从属关系表列表
// @Tags 用户绑定从属关系表
// @Param groupName query string false "用户组名称"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineApiGroup}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-api-group [get]
// @Security Bearer
func (e LineApiGroup) GetPage(c *gin.Context) {
	req := dto.LineApiGroupGetPageReq{}
	s := service.LineApiGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.Form, binding.Query).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineApiGroup, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取用户绑定从属关系表失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取用户绑定从属关系表
// @Summary 获取用户绑定从属关系表
// @Description 获取用户绑定从属关系表
// @Tags 用户绑定从属关系表
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineApiGroup} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-api-group/{id} [get]
// @Security Bearer
func (e LineApiGroup) Get(c *gin.Context) {
	req := dto.LineApiGroupGetReq{}
	s := service.LineApiGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineApiGroup

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取用户绑定从属关系表失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建用户绑定从属关系表
// @Summary 创建用户绑定从属关系表
// @Description 创建用户绑定从属关系表
// @Tags 用户绑定从属关系表
// @Accept application/json
// @Product application/json
// @Param data body dto.LineApiGroupInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-api-group [post]
// @Security Bearer
func (e LineApiGroup) Insert(c *gin.Context) {
	req := dto.LineApiGroupInsertReq{}
	s := service.LineApiGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	if err := req.Valid(); err != nil {
		e.Error(500, err, err.Error())
		return
	}

	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建用户绑定从属关系表失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改用户绑定从属关系表
// @Summary 修改用户绑定从属关系表
// @Description 修改用户绑定从属关系表
// @Tags 用户绑定从属关系表
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineApiGroupUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-api-group/{id} [put]
// @Security Bearer
func (e LineApiGroup) Update(c *gin.Context) {
	req := dto.LineApiGroupUpdateReq{}
	s := service.LineApiGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改用户绑定从属关系表失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除用户绑定从属关系表
// @Summary 删除用户绑定从属关系表
// @Description 删除用户绑定从属关系表
// @Tags 用户绑定从属关系表
// @Param data body dto.LineApiGroupDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-api-group [delete]
// @Security Bearer
func (e LineApiGroup) Delete(c *gin.Context) {
	s := service.LineApiGroup{}
	req := dto.LineApiGroupDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除用户绑定从属关系表失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}
